package complicit

import soot.{Unit => SootUnit, util => _, _}
import soot.toolkits.graph._
import soot.jimple._
import soot.util.cfgcmd.CFGToDotGraph
import soot.util.dot._

object Lattice {
  object Level extends Enumeration {
    type Level = Value
    val L, H = Value
  }
  import Level._

  def levels: Set[Level] = Level.values

  def le(l1: Level, l2: Level) =
    (l1, l2) match {
      case (_, H) => true
      case (L, L) => true
      case _ => false
    }

  def join(l1: Level, l2: Level): Level =
    (l1, l2) match {
      case (L, L) => L
      case _ => H
    }
  def top: Level = H
  def bot: Level = L
}
